datablock AudioProfile(mSnowBallHitSound)
{
   filename    = "./hitSound.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock ParticleData(mSnowBallSparkParticle)
{
   dragCoefficient      = 4;
   gravityCoefficient   = 1;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 400;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/chunk";
	
	useInvAlpha = false;
	spinSpeed		= 150.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;

   colors[0]     = "0.30 0.10 0.0 0.0";
   colors[1]     = "0.30 0.10 0.0 0.5";
   colors[2]     = "0.30 0.10 0.0 0.0";
   sizes[0]      = 0.15;
   sizes[1]      = 0.15;
   sizes[2]      = 0.15;

   times[0]	= 0.1;
   times[1] = 0.5;
   times[2] = 1.0;

   useInvAlpha = true;
};

datablock ParticleEmitterData(mSnowBallSparkEmitter)
{
	lifeTimeMS = 10;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 3.0;
   ejectionOffset   = 1.50;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = mSnowBallSparkParticle;
};




datablock ParticleData(mSnowBallExplosionParticle)
{
   dragCoefficient      = 10;
   gravityCoefficient   = -0.15;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 800;
   lifetimeVarianceMS   = 500;
   textureName          = "base/data/particles/cloud";

	spinSpeed		= 50.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;

   colors[0]     = "1.0 1.0 1.0 0.25";
   colors[1]     = "0.0 0.0 0.0 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 1.0;

   useInvAlpha = true;
};

datablock ParticleEmitterData(mSnowBallExplosionEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 95;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = mSnowBallExplosionParticle;

   emitterNode = HalfEmitterNode;
};

datablock ExplosionData(mSnowBallExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 400;
   
   //emitter[0] = mSnowBallExplosionEmitter;
   emitter[0] = mSnowBallSparkEmitter;
   particleEmitter = mSnowBallExplosionEmitter;
   particleDensity = 30;
	particleRadius = 1.0;
   
   faceViewer     = true;
   explosionScale = "1 1 1";

   soundProfile = mSnowBallHitSound;

   
   shakeCamera = true;
   cameraShakeFalloff = false;
   camShakeFreq = "2.0 3.0 1.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 2.5;
   camShakeRadius = 0.0001;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "0.0 0.0 0.0";
   lightEndColor = "0 0 0";
};
datablock ProjectileData(mSnowballProjectile:blankaBallProjectile)
{
   shapeFile="base/data/shapes/snowBall.dts";
   explosion=mSnowBallExplosion;
   uiname="";
};
datablock ShapeBaseImageData(mSnowBallImage:printgunImage)
{
   armReady=0;
   offset="0 0 0";
   eyeOffset="0.35 0.5 -0.25";
   shapeFile="base/data/shapes/snowBall.dts";
   projectile="";
};
function mSnowBallImage::onFire(%data,%obj,%slot)
{
   %obj.unMountImage(%slot);
   %p = new Projectile()
   {
      dataBlock = mSnowballProjectile;
      initialVelocity = vectorScale(%obj.getEyeVector(),20);
      initialPosition = vectorScale(vectorAdd(%obj.getEyePoint(),%obj.getHackPosition()),0.5);
      sourceObject = %obj;
      sourceSlot = %slot;
      client = %obj.client;
   };
   %p.setScale("1 1 1");
   serverPlay3d(brickPlantSound,%obj.getHackPosition());
}
datablock PlayerData(mNoMovePlayer:PlayerStandardArmor)
{
   maxForwardSpeed = 0;
   maxBackwardSpeed = 0;
   maxSideSpeed = 0;

   maxForwardCrouchSpeed = 0;
   maxBackwardCrouchSpeed = 0;
   maxSideCrouchSpeed = 0;

	canJet = 0;
	uiname = "";
};
function Player::pickupSnowball(%obj)
{
   %obj.cantPickupBall=1;
   serverPlay3d(BrickChangeSound,%obj.getHackPosition());
   schedule(1000,0,serverPlay3d,brickRotateSound,%obj.getHackPosition());
   %obj.playthread(2,Activate2);
   %obj.schedule(1000,playThread,2,root);
   %obj.schedule(1000,mountImage,mSnowBallImage,0);
   %data=%obj.getdatablock();
   %obj.setDatablock(mNoMovePlayer);
   %obj.schedule(1000,setDatablock,%data);
   schedule(1000,0,eval,"if(isObject("@%obj@"))"@%obj@".cantPickupBall=0;");
}
package mSnowballPackage
{
   function Player::ActivateStuff(%obj)
   {
      Parent::ActivateStuff(%obj);
      if(%obj.cantPickupBall||isObject(%obj.getMountedImage(0)))
         return;
      %ray=containerRaycast(%obj.getEyePoint(),vectorAdd(%obj.getEyePoint(),vectorScale(%obj.getEyeVector(),5)),$TypeMasks::FxBrickObjectType,%obj);
      if(isObject(%col=firstWord(%ray)))
      {
         if(vectorDist(getWords(getColorIDTable(%col.colorID),0,2),"1 1 1")<0.1)
            %obj.pickupSnowball();
      }
   }
};
activatepackage(mSnowballPackage);
function Player::mSnowballFlail(%obj,%normal)
{
   %obj.cantBeHit=1;
   %obj.addVelocity(vectorScale(getWords(%normal,0,1) SPC 0.5,10));
   %obj.setNodecolor("ALL","1 1 1 1");
   %obj.playThread(1,"death1");
   %obj.schedule(3000,playThread,1,"root");
   %m=%obj.client.camera;
   %m.setFlyMode();
   %m.mode = "Observer";
   %obj.client.setControlObject(%m);
   %m.setOrbitMode(%obj,%obj.getHackPosition(), 0, 6, 6, 0);
   schedule(3000,0,eval,"if(isObject("@%obj@")&&"@%obj@".getState()!$=\"DEAD\"){"@%obj.client@".applyBodyColors();"@%obj.client@".setControlObject("@%obj@");"@%obj@".cantBeHit=0;}");
}
function mSnowballProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
   if(!minigameCanDamage(%obj,%col)||!isObject(getminigameFromobject(%obj)))
      return;
	%vel = %obj.getVelocity();
	%speed = vectorLen(%vel);
	
	%source = %obj.client;
	%sourcePos = %obj.originPoint;
	%sourceName = %obj.client.name;
	%wasThrown = %obj.wasThrown;
	if(%col.getClassName()$="Player"&&!%col.cantBeHit)
	{
	   %col.mSnowballFlail(%normal);
	   if(isObject(%client=%obj.sourceobject.client))
	   {
	      %pos1 = getWords( %obj.sourceobject.getPosition(), 0, 1 );
         %pos2 = getWords( %col.getPosition(), 0, 1 );
         
         %dist = vectorDist( %pos1, %pos2 )*1.875;//*1.86;
         
         %dist = mFloatLength( %dist, 0 );
         
         // build the message
         %color = "<color:ffff00>";
         %wColor = "<color:FFFFFF>";
         %rColor = "<color:FF0000>";
         
         %prefix = "<bitmap:base/client/ui/CI/star>\c4 Snowball \c6";
         %suffix = " \c6at\c4" SPC %dist @ "ft!";
         
         if( isObject( %col.client ) )
            %col.client.bottomPrint( %prefix@"from \c4"@%client.name@%suffix, 5 );
         %client.bottomPrint( %prefix@"to\c4 "@%col.client.name@%suffix, 5 );
	   }
	}
	parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
}